#!/usr/bin/perl
#
#rrdtool create plm_cpu_cur.rrd --step 60
#   DS:audit:GAUGE:600:0:32
#   DS:dw01:GAUGE:600:0:32
#   DS:dw02:GAUGE:600:0:32
#   DS:risk_ALM:GAUGE:600:0:32
#   DS:risk_RDW:GAUGE:600:0:32
#   DS:sacha:GAUGE:600:0:32
#
#   RRA:AVERAGE:0.5:1:105120   --> Average for 1 min (for 2 year data)
#   RRA:AVERAGE:0.5:60:17520   --> Average for 60 min or 1 hour (for 2 year data)
#   RRA:AVERAGE:0.5:1440:730   --> Average for 1440 min or 1 day (for 2 year data)
#   RRA:AVERAGE:0.5:10080:105  --> Average for 10080 min or 1 week (for 2 year data)
#   RRA:AVERAGE:0.5:43200:24   --> Average for 43200 min or 1 month (for 2 year data)
#   RRA:AVERAGE:0.5:172800:8   --> Average for 172800 min or 4 month (for 2 year data)

$group_file='/usr/local/omsEnhanced/conf/grouplist.cfg';
open(FIN, $group_file);
@groups=<FIN>;

foreach $group (@groups) {
  @group_items=split(/ /, $group);
  
  # Fetch resource usage data for each LPAR using xlpstat command
  system("/usr/sbin/xlpstat -r -p /etc/plm/policies/$group_items[1]|grep -v ^# > /usr/local/omsEnhanced/data/current.data");
  
  $file = '/usr/local/omsEnhanced/data/current.data';
  open(PLM, $file);
  @lpars = <PLM>;
  
  my(@rrd_cpu_cur_args) = (
            "/usr/local/omsEnhanced/data/$group_items[0]_cpu_cur.rrd",
            "--step=60"
          );

  my(@rrd_cpu_pct_args) = (
            "/usr/local/omsEnhanced/data/$group_items[0]_cpu_pct.rrd",
            "--step=60"
          );          

  my(@rrd_cpu_total_pct_args) = (
            "/usr/local/omsEnhanced/data/$group_items[0]_cpu_total_pct.rrd",
            "--step=60"
          );          
          
  my(@rrd_cpu_load_args) = (
            "/usr/local/omsEnhanced/data/$group_items[0]_cpu_load.rrd",
            "--step=60"
          );    
          
  my(@rrd_mem_cur_args) = (
            "/usr/local/omsEnhanced/data/$group_items[0]_mem_cur.rrd",
            "--step=60"
          ); 
          
  my(@rrd_mem_pct_args) = (
            "/usr/local/omsEnhanced/data/$group_items[0]_mem_pct.rrd",
            "--step=60"
          );           
  
  my(@rrd_mem_total_pct_args) = (
            "/usr/local/omsEnhanced/data/$group_items[0]_mem_total_pct.rrd",
            "--step=60"
          );           
      
  foreach $lpar (@lpars)
  {
    @items = split(/:/,$lpar);  
    push(@rrd_cpu_cur_args, "DS:$items[0]:GAUGE:600:0:$group_items[2]");
    push(@rrd_cpu_pct_args, "DS:$items[0]:GAUGE:600:0:100");
    push(@rrd_cpu_total_pct_args, "DS:$items[0]:GAUGE:600:0:100");
    push(@rrd_cpu_load_args, "DS:$items[0]:GAUGE:600:0:10");

    push(@rrd_mem_cur_args, "DS:$items[0]:GAUGE:600:0:$group_items[3]");
    push(@rrd_mem_pct_args, "DS:$items[0]:GAUGE:600:0:100");
    push(@rrd_mem_total_pct_args, "DS:$items[0]:GAUGE:600:0:100");
  }

  push(@rrd_cpu_cur_args, "RRA:AVERAGE:0.5:1:105120");
  push(@rrd_cpu_cur_args, "RRA:AVERAGE:0.5:60:17520");
  push(@rrd_cpu_cur_args, "RRA:AVERAGE:0.5:1440:730");
  push(@rrd_cpu_cur_args, "RRA:AVERAGE:0.5:10080:105");
  push(@rrd_cpu_cur_args, "RRA:AVERAGE:0.5:43200:24");
  push(@rrd_cpu_cur_args, "RRA:AVERAGE:0.5:172800:8");

  push(@rrd_cpu_pct_args, "RRA:AVERAGE:0.5:1:105120");
  push(@rrd_cpu_pct_args, "RRA:AVERAGE:0.5:60:17520");
  push(@rrd_cpu_pct_args, "RRA:AVERAGE:0.5:1440:730");
  push(@rrd_cpu_pct_args, "RRA:AVERAGE:0.5:10080:105");
  push(@rrd_cpu_pct_args, "RRA:AVERAGE:0.5:43200:24");
  push(@rrd_cpu_pct_args, "RRA:AVERAGE:0.5:172800:8");
  
  push(@rrd_cpu_total_pct_args, "RRA:AVERAGE:0.5:1:105120");
  push(@rrd_cpu_total_pct_args, "RRA:AVERAGE:0.5:60:17520");
  push(@rrd_cpu_total_pct_args, "RRA:AVERAGE:0.5:1440:730");
  push(@rrd_cpu_total_pct_args, "RRA:AVERAGE:0.5:10080:105");
  push(@rrd_cpu_total_pct_args, "RRA:AVERAGE:0.5:43200:24");
  push(@rrd_cpu_total_pct_args, "RRA:AVERAGE:0.5:172800:8");

  push(@rrd_cpu_load_args, "RRA:AVERAGE:0.5:1:105120");
  push(@rrd_cpu_load_args, "RRA:AVERAGE:0.5:60:17520");
  push(@rrd_cpu_load_args, "RRA:AVERAGE:0.5:1440:730");
  push(@rrd_cpu_load_args, "RRA:AVERAGE:0.5:10080:105");
  push(@rrd_cpu_load_args, "RRA:AVERAGE:0.5:43200:24");
  push(@rrd_cpu_load_args, "RRA:AVERAGE:0.5:172800:8");
    
  system("rrdtool create @rrd_cpu_cur_args 1>/dev/null");    
  system("rrdtool create @rrd_cpu_pct_args 1>/dev/null");    
  system("rrdtool create @rrd_cpu_total_pct_args 1>/dev/null");    
  system("rrdtool create @rrd_cpu_load_args 1>/dev/null");    
  
  push(@rrd_mem_cur_args, "RRA:AVERAGE:0.5:1:105120");
  push(@rrd_mem_cur_args, "RRA:AVERAGE:0.5:60:17520");
  push(@rrd_mem_cur_args, "RRA:AVERAGE:0.5:1440:730");
  push(@rrd_mem_cur_args, "RRA:AVERAGE:0.5:10080:105");
  push(@rrd_mem_cur_args, "RRA:AVERAGE:0.5:43200:24");
  push(@rrd_mem_cur_args, "RRA:AVERAGE:0.5:172800:8");

  push(@rrd_mem_pct_args, "RRA:AVERAGE:0.5:1:105120");
  push(@rrd_mem_pct_args, "RRA:AVERAGE:0.5:60:17520");
  push(@rrd_mem_pct_args, "RRA:AVERAGE:0.5:1440:730");
  push(@rrd_mem_pct_args, "RRA:AVERAGE:0.5:10080:105");
  push(@rrd_mem_pct_args, "RRA:AVERAGE:0.5:43200:24");
  push(@rrd_mem_pct_args, "RRA:AVERAGE:0.5:172800:8");

  push(@rrd_mem_total_pct_args, "RRA:AVERAGE:0.5:1:105120");
  push(@rrd_mem_total_pct_args, "RRA:AVERAGE:0.5:60:17520");
  push(@rrd_mem_total_pct_args, "RRA:AVERAGE:0.5:1440:730");
  push(@rrd_mem_total_pct_args, "RRA:AVERAGE:0.5:10080:105");
  push(@rrd_mem_total_pct_args, "RRA:AVERAGE:0.5:43200:24");
  push(@rrd_mem_total_pct_args, "RRA:AVERAGE:0.5:172800:8");

  system("rrdtool create @rrd_mem_cur_args 1>/dev/null");
  system("rrdtool create @rrd_mem_pct_args 1>/dev/null");
  system("rrdtool create @rrd_mem_total_pct_args 1>/dev/null");

  print("OMS Database has been created with the following commands\n");
  print("rrdtool create @rrd_cpu_cur_args 1>/dev/null"); 
  print("\n");
  print("rrdtool create @rrd_cpu_pct_args 1>/dev/null");
  print("\n");
  print("rrdtool create @rrd_cpu_total_pct_args 1>/dev/null");    
  print("\n");
  print("rrdtool create @rrd_cpu_load_args 1>/dev/null");     

  print("\n");
  print("rrdtool create @rrd_mem_cur_args 1>/dev/null");     
  print("\n");
  print("rrdtool create @rrd_mem_pct_args 1>/dev/null");     
  print("\n");
  print("rrdtool create @rrd_mem_total_pct_args 1>/dev/null");     
}
