#!/usr/bin/perl -w

print "Content-type: text/html\r\n\r\n";

require "./config.pl";

$group_file="${top_dir}conf/grouplist.cfg";
open(FIN, $group_file);
@groups=<FIN>;

print"<TABLE border=0 align=center width='950'>";
foreach $group (@groups) {
@group_items=split(/ /, $group);

#
# Initializing varaibles for this page
#
my(@rrd_graph_args) = (
            "${top_dir}htdocs${htdocs_dir}images/oms-cpu-group-overview-$group_items[0].gif",
            "--title=\"Consolidated CPU Utilization for $group_items[0]\"",
            "--vertical-label=\"CPU Utilization (%)\"",
            "--start=00:00",
            "--end=23:59",
            "--step=60",
            "--width=450",
            "--height=180",
            "--upper-limit=100",
            "--lower-limit=0",
            "--rigid"
          );
$cnt=0;
$cpu_inuse=0;

#
# Gathering the current CPU allocation status from the result of xlpstat for each PLM group
#
open(PLMIN, "< ${top_dir}tmp/xlpstat_$group_items[0]");
@lines=<PLMIN>;
if (@lines != 0) {
foreach $line (@lines) {
  @items=split(/:/, $line);
  $cpu_inuse=$cpu_inuse+$items[4];
  push(@rrd_graph_args, "DEF:$items[0]=${top_dir}data/$group_items[0]_cpu_total_pct.rrd:$items[0]:AVERAGE");
  push(@rrd_graph_args, "AREA:$items[0]$colors[$cnt]:$items[0]:STACK");  
  $cnt=$cnt+1;
}

$cpu_inuse_pct=100*$cpu_inuse/$group_items[2];
$cpu_free=$group_items[2]-$cpu_inuse;
$cpu_free_pct=100-$cpu_inuse_pct;

#
# Generating CPU utilization graph for each PLM group
#
#RRDs::graph @rrd_graph_args; 
system "rrdtool graph @rrd_graph_args 1>/dev/null";

print <<HTMLEND;
  <tr> 
    <td align=left colspan="2">
    <table width="100%" cellpadding="2" cellspacing="2">
      <tr> 
        <td BGCOLOR="#000000"><a href="${htdocs_dir}oms/oms-cpu-partition-overview.html?group=$group_items[0]">$group_items[0]</a></td>
      </tr>
    </table>    
    </td>
  </tr>
  <tr> 
    <td valign=top align=center width="560">
      <img src=${htdocs_dir}images/oms-cpu-group-overview-$group_items[0].gif>
    </td>
    <td valign=top align=left> 
      <table width="95%" cellpadding="2" cellspacing="2" bgcolor="#000000">
        <tr> 
          <td BGCOLOR="#000000"><font color="white">Total CPU Resource Status</font></td>
          <td BGCOLOR="#000000" align=right><a href="${htdocs_dir}oms/oms-cpu-partition-overview.html?group=$group_items[0]"><font color="white">Detail</font></a></td>
        </tr>
      </table>      
      <TABLE class="oms" width="95%">
        <TR bgcolor="#666666"> 
          <TD width="33%"> 
            <div align="center"><b><font color="#FFFFFF">&nbsp</font></b></div>
          </TD>
          <TD> 
            <div align="center"><b><font color="#FFFFFF"># of CPU</font></b></div>
          </TD>
          <TD width="33%"> 
            <div align="center"><b><font color="#FFFFFF">%</font></b></div>
          </TD>
        </TR>
        <TR> 
          <TD width="33%"> 
            <div align="center">In Use</div>
          </TD>
          <TD> 
            <div align="right">$cpu_inuse</div>
          </TD>
          <TD width="33%"> 
            <div align="right">$cpu_inuse_pct</div>
          </TD>
        </TR>
        <TR> 
          <TD width="33%"> 
            <div align="center">Free Pool</div>
          </TD>
          <TD> 
            <div align="right">$cpu_free</div>
          </TD>
          <TD width="33%"> 
            <div align="right">$cpu_free_pct</div>
          </TD>
        </TR>		
        <TR> 
          <TD width="33%"> 
            <div align="center">Total</div>
          </TD>
          <TD> 
            <div align="right">$group_items[2]</div>
          </TD>
          <TD width="33%"> 
            <div align="right">&nbsp;</div>
          </TD>
        </TR>		
      </TABLE>
    </td>
  </tr>
HTMLEND
}
}
print "</table>";
