#!/usr/bin/perl
#use lib qw( /usr/local/rrdtool/lib/perl/5.8.0 );
#use RRDs;
use CGI qw/:standard/;
use Time::Local;

print "Content-type: text/html\r\n\r\n";

require "./config.pl";

$req_group=param("group");
$req_partition=param("partition");
$req_cpu_choice=param("cpu_choice");
if ($req_cpu_choice eq "") {
  $req_cpu_choice = "cnt";
}

@current_date = localtime time;

$end_year=param("year");
$end_month=param("month");
$end_day=param("day");

if ($end_year eq  "") {
  $end_year = 1900 + $current_date[5];
}

if ($end_month eq "") {
  $end_month = 1 + $current_date[4];
} elsif (length($end_month) == 1) {
  $end_month="0".$end_month;
} 

if ($end_day eq "") {
  $end_day = $current_date[3];
} elsif (length($end_day) == 1) {
  $end_day="0".$end_day;
} 

$quarter=int( ($end_month+2) / 3 ) * 3;
if (length($quarter) == 1) {
  $quarter = "0" . $quarter;
}

$end_date = $end_year.$end_month.$end_day;

$current_date[0]=59;
$current_date[1]=59;
$current_date[2]=23;
$current_date[3]=$end_day;
$current_date[4]=$end_month-1;
$end_epoch_time=timelocal(@current_date);

open(FIN, $group_file);
@groups=<FIN>;

print"<link rel='stylesheet' href='oms.css' type='text/css'>";
print"<TABLE border=0 align=center width='950'>";

$group_select_html="";

foreach $group (@groups) {
  @group_items=split(/ /, $group);

  if ($group_items[0] eq $req_group) {
    $cpu_total=$group_items[2];

#
# Initializing varaibles for this page
#
my(@cpu_pct_day_graph_args) = (
            "${top_dir}htdocs${htdocs_dir}oms/images/oms-cpu-partition-day-$group_items[0]-$req_partition.gif",
            "--title=\"CPU Utilization (Day average) [$end_year/$end_month/$end_day]\"",
            "--vertical-label=\"CPU Utilization (%)\"",
            "--start=end-1days",
            "--end=$end_epoch_time",
            "--width=330",
            "--height=150",
            "--upper-limit=100",
            "--lower-limit=0",
            "--rigid",           
          );

my(@cpu_pct_week_graph_args) = (
            "${top_dir}htdocs${htdocs_dir}oms/images/oms-cpu-partition-week-$group_items[0]-$req_partition.gif",
            "--title=\"CPU Utilization (Week average) [$end_year/$end_month/$end_day]\"",
            "--vertical-label=\"CPU Utilization (%)\"",
            "--start=end-1weeks",
            "--end=$end_epoch_time",
            "--width=330",
            "--height=180",
            "--upper-limit=100",
            "--lower-limit=0",
            "--rigid"
          );
          
my(@cpu_pct_month_graph_args) = (
            "${top_dir}htdocs${htdocs_dir}oms/images/oms-cpu-partition-month-$group_items[0]-$req_partition.gif",
            "--title=\"CPU Utilization (Month average) [$end_year/$end_month/$end_day]\"",
            "--vertical-label=\"CPU Utilization (%)\"",
            "--start=end-1months",
            "--end=$end_epoch_time",
            "--width=330",
            "--height=180",
            "--upper-limit=100",
            "--lower-limit=0",
            "--rigid"
          );

my(@cpu_pct_quarter_graph_args) = (
            "${top_dir}htdocs${htdocs_dir}oms/images/oms-cpu-partition-quarter-$group_items[0]-$req_partition.gif",
            "--title=\"CPU Utilization (Quarter average) [$end_year/$end_month/$end_day]\"",
            "--vertical-label=\"CPU Utilization (%)\"",
            "--start=end-3months",
            "--end=$end_year$quarter"."31",
            "--width=330",
            "--height=180",
            "--upper-limit=100",
            "--lower-limit=0",
            "--rigid"
          );
          
my(@cpu_pct_year_graph_args) = (
            "${top_dir}htdocs${htdocs_dir}oms/images/oms-cpu-partition-year-$group_items[0]-$req_partition.gif",
            "--title=\"CPU Utilization (Year average) [$end_year/$end_month/$end_day]\"",
            "--vertical-label=\"CPU Utilization (%)\"",
            "--start=end-1years",
            "--end=$end_epoch_time",
            "--width=330",
            "--height=180",
            "--upper-limit=100",
            "--lower-limit=0",
            "--rigid"
          );

#
# Initializing graph defintion for the number of CPUs
#                                                  
my(@cpu_cnt_day_graph_args) = (
            "${top_dir}htdocs${htdocs_dir}oms/images/oms-cpu-cnt-partition-day-$group_items[0]-$req_partition.gif",
            "--title=\"CPU Allocation (Day average) [$end_year/$end_month/$end_day]\"",
            "--vertical-label=\"Number of allocated CPUs\"",
            "--start=end-1days",
            "--end=$end_epoch_time",
            "--width=330",
            "--height=150",
            "--upper-limit=$cpu_total",
            "--lower-limit=0",            
            "--rigid"
          );
          
my(@cpu_cnt_week_graph_args) = (
            "${top_dir}htdocs${htdocs_dir}oms/images/oms-cpu-cnt-partition-week-$group_items[0]-$req_partition.gif",
            "--title=\"CPU Allocation (Week average) [$end_year/$end_month/$end_day]\"",
            "--vertical-label=\"Number of allocated CPUs\"",
            "--start=end-1weeks",
            "--end=$end_epoch_time",
            "--width=330",
            "--height=180",
            "--upper-limit=$cpu_total",
            "--lower-limit=0",            
            "--rigid"
          );
          
my(@cpu_cnt_month_graph_args) = (
            "${top_dir}htdocs${htdocs_dir}oms/images/oms-cpu-cnt-partition-month-$group_items[0]-$req_partition.gif",
            "--title=\"CPU Allocation (Month average) [$end_year/$end_month/$end_day]\"",
            "--vertical-label=\"Number of allocated CPUs\"",
            "--start=end-1months",
            "--end=$end_epoch_time",
            "--width=330",
            "--height=180",
            "--upper-limit=$cpu_total",
            "--lower-limit=0",            
            "--rigid"
          );
          
my(@cpu_cnt_quarter_graph_args) = (
            "${top_dir}htdocs${htdocs_dir}oms/images/oms-cpu-cnt-partition-quarter-$group_items[0]-$req_partition.gif",
            "--title=\"CPU Allocation (Quarter average) [$end_year/$end_month/$end_day]\"",
            "--vertical-label=\"Number of allocated CPUs\"",
            "--start=end-3months",
            "--end=$end_year$quarter"."31",
            "--width=330",
            "--height=180",
            "--upper-limit=$cpu_total",
            "--lower-limit=0",            
            "--rigid"
          );
my(@cpu_cnt_year_graph_args) = (
            "${top_dir}htdocs${htdocs_dir}oms/images/oms-cpu-cnt-partition-year-$group_items[0]-$req_partition.gif",
            "--title=\"CPU Allocation (Year average) [$end_year/$end_month/$end_day]\"",
            "--vertical-label=\"Number of allocated CPUs\"",
            "--start=end-1years",
            "--end=$end_epoch_time",
            "--width=330",
            "--height=180",
            "--upper-limit=$cpu_total",
            "--lower-limit=0",            
            "--rigid"
          );                              

#
# Initializing graph defintion for the CPU load
#                                                  
my(@cpu_load_day_graph_args) = (
            "${top_dir}htdocs${htdocs_dir}oms/images/oms-cpu-load-partition-day-$group_items[0]-$req_partition.gif",
            "--title=\"CPU Load (Day average) [$end_year/$end_month/$end_day]\"",
            "--vertical-label=\"CPU Load (run queue / CPU)\"",
            "--start=end-1days",
            "--end=$end_epoch_time",
            "--width=330",
            "--height=150",
            "--lower-limit=0",            
            "--rigid"         
          );
          
my(@cpu_load_week_graph_args) = (
            "${top_dir}htdocs${htdocs_dir}oms/images/oms-cpu-load-partition-week-$group_items[0]-$req_partition.gif",
            "--title=\"CPU Load (Week average) [$end_year/$end_month/$end_day]\"",
            "--vertical-label=\"CPU Load (run queue / CPU)\"",
            "--start=end-1weeks",
            "--end=$end_epoch_time",
            "--width=330",
            "--height=180",
            "--lower-limit=0",            
            "--rigid"
          );
          
my(@cpu_load_month_graph_args) = (
            "${top_dir}htdocs${htdocs_dir}oms/images/oms-cpu-load-partition-month-$group_items[0]-$req_partition.gif",
            "--title=\"CPU Load (Month average) [$end_year/$end_month/$end_day]\"",
            "--vertical-label=\"CPU Load (run queue / CPU)\"",
            "--start=end-1months",
            "--end=$end_epoch_time",
            "--width=330",
            "--height=180",
            "--lower-limit=0",            
            "--rigid"
          );
          
my(@cpu_load_quarter_graph_args) = (
            "${top_dir}htdocs${htdocs_dir}oms/images/oms-cpu-load-partition-quarter-$group_items[0]-$req_partition.gif",
            "--title=\"CPU Load (Quarter average) [$end_year/$end_month/$end_day]\"",
            "--vertical-label=\"CPU Load (run queue / CPU)\"",
            "--start=end-3months",
            "--end=$end_year$quarter"."31",
            "--width=330",
            "--height=180",
            "--lower-limit=0",            
            "--rigid"
          );
my(@cpu_load_year_graph_args) = (
            "${top_dir}htdocs${htdocs_dir}oms/images/oms-cpu-load-partition-year-$group_items[0]-$req_partition.gif",
            "--title=\"CPU Load (Year average) [$end_year/$end_month/$end_day]\"",
            "--vertical-label=\"CPU Load (run queue / CPU)\"",
            "--start=end-1years",
            "--end=$end_epoch_time",
            "--width=330",
            "--height=180",
            "--lower-limit=0",            
            "--rigid"
          );  
                              
$cnt=0;
$cpu_inuse=0;
$partition_cpu_table="";
$partition_select_html="";
$now = localtime time;

#
# Gathering the current CPU allocation status from the result of xlpstat for each PLM group
#
open(PLMIN, "< ${top_dir}tmp/xlpstat_$group_items[0]");
@lines=<PLMIN>;

foreach $line (@lines) {
  @items=split(/:/, $line);
  
  if ($items[0] eq $req_partition) {
    $partition_select_html = $partition_select_html . "<option value='$items[0]' selected>$items[0]</option>";
      
    push(@cpu_pct_day_graph_args, "DEF:$items[0]=${top_dir}data/$group_items[0]_cpu_pct.rrd:$items[0]:AVERAGE");
    push(@cpu_pct_day_graph_args, "AREA:$items[0]$colors[$cnt]:$items[0]");   
    push(@cpu_pct_day_graph_args, "COMMENT:\"  \\n\"");    
    push(@cpu_pct_day_graph_args, "COMMENT:\"---------------------------\\n\"");
    push(@cpu_pct_day_graph_args, "COMMENT:\"Maximum  Minimum  Average\\n\"");
    push(@cpu_pct_day_graph_args, "GPRINT:$items[0]:MAX:\"%7.2lf\"");
    push(@cpu_pct_day_graph_args, "GPRINT:$items[0]:MIN:\"%6.2lf\"");
    push(@cpu_pct_day_graph_args, "GPRINT:$items[0]:AVERAGE:\"%6.2lf\"");

    push(@cpu_pct_week_graph_args, "DEF:$items[0]=${top_dir}data/$group_items[0]_cpu_pct.rrd:$items[0]:AVERAGE");
    push(@cpu_pct_week_graph_args, "AREA:$items[0]$colors[$cnt]:$items[0]"); 
    push(@cpu_pct_week_graph_args, "COMMENT:\"  \\n\"");    
    push(@cpu_pct_week_graph_args, "COMMENT:\"---------------------------\\n\"");
    push(@cpu_pct_week_graph_args, "COMMENT:\"Maximum  Minimum  Average\\n\"");
    push(@cpu_pct_week_graph_args, "GPRINT:$items[0]:MAX:\"%7.2lf\"");
    push(@cpu_pct_week_graph_args, "GPRINT:$items[0]:MIN:\"%6.2lf\"");
    push(@cpu_pct_week_graph_args, "GPRINT:$items[0]:AVERAGE:\"%6.2lf\"");
  
    push(@cpu_pct_month_graph_args, "DEF:$items[0]=${top_dir}data/$group_items[0]_cpu_pct.rrd:$items[0]:AVERAGE");
    push(@cpu_pct_month_graph_args, "AREA:$items[0]$colors[$cnt]:$items[0]"); 
    push(@cpu_pct_month_graph_args, "COMMENT:\"  \\n\"");    
    push(@cpu_pct_month_graph_args, "COMMENT:\"---------------------------\\n\"");
    push(@cpu_pct_month_graph_args, "COMMENT:\"Maximum  Minimum  Average\\n\"");
    push(@cpu_pct_month_graph_args, "GPRINT:$items[0]:MAX:\"%7.2lf\"");
    push(@cpu_pct_month_graph_args, "GPRINT:$items[0]:MIN:\"%6.2lf\"");
    push(@cpu_pct_month_graph_args, "GPRINT:$items[0]:AVERAGE:\"%6.2lf\"");
      
    push(@cpu_pct_quarter_graph_args, "DEF:$items[0]=${top_dir}data/$group_items[0]_cpu_pct.rrd:$items[0]:AVERAGE");
    push(@cpu_pct_quarter_graph_args, "AREA:$items[0]$colors[$cnt]:$items[0]"); 
    push(@cpu_pct_quarter_graph_args, "COMMENT:\"  \\n\"");    
    push(@cpu_pct_quarter_graph_args, "COMMENT:\"---------------------------\\n\"");
    push(@cpu_pct_quarter_graph_args, "COMMENT:\"Maximum  Minimum  Average\\n\"");
    push(@cpu_pct_quarter_graph_args, "GPRINT:$items[0]:MAX:\"%7.2lf\"");
    push(@cpu_pct_quarter_graph_args, "GPRINT:$items[0]:MIN:\"%6.2lf\"");
    push(@cpu_pct_quarter_graph_args, "GPRINT:$items[0]:AVERAGE:\"%6.2lf\"");
        
    push(@cpu_pct_year_graph_args, "DEF:$items[0]=${top_dir}data/$group_items[0]_cpu_pct.rrd:$items[0]:AVERAGE");
    push(@cpu_pct_year_graph_args, "AREA:$items[0]$colors[$cnt]:$items[0]");       
    push(@cpu_pct_year_graph_args, "COMMENT:\"  \\n\"");    
    push(@cpu_pct_year_graph_args, "COMMENT:\"---------------------------\\n\"");
    push(@cpu_pct_year_graph_args, "COMMENT:\"Maximum  Minimum  Average\\n\"");
    push(@cpu_pct_year_graph_args, "GPRINT:$items[0]:MAX:\"%7.2lf\"");
    push(@cpu_pct_year_graph_args, "GPRINT:$items[0]:MIN:\"%6.2lf\"");
    push(@cpu_pct_year_graph_args, "GPRINT:$items[0]:AVERAGE:\"%6.2lf\"");
        
    if ($req_cpu_choice eq "cnt") {
      get_cpu_max_min($group_items[1], $items[0]);      
      $is_cnt_checked="checked";
      $is_load_checked="";
      $cpu_title="CPU Allocation Statistics";
      $cpu_upper_limit=${cpu_total};
      if ( ${cpu_max} > 0 ) {
          $cpu_upper_limit=$cpu_max*1.2;
      }
      #
      # Number of allocated CPU argument generation
      #
      push(@cpu_cnt_day_graph_args, "DEF:$items[0]=${top_dir}data/$group_items[0]_cpu_cur.rrd:$items[0]:AVERAGE");
      push(@cpu_cnt_day_graph_args, "AREA:$items[0]$colors[$cnt]:$items[0]");
      push(@cpu_cnt_day_graph_args, "LINE3:$cpu_max#FF0000:\"CPU High\"");
      push(@cpu_cnt_day_graph_args, "LINE3:$cpu_min#0000FF:\"CPU Low\"");      
      push(@cpu_cnt_day_graph_args, "COMMENT:\"  \\n\"");    
      push(@cpu_cnt_day_graph_args, "COMMENT:\"---------------------------\\n\"");
      push(@cpu_cnt_day_graph_args, "COMMENT:\"Maximum  Minimum  Average\\n\"");
      push(@cpu_cnt_day_graph_args, "GPRINT:$items[0]:MAX:\"%7.2lf\"");
      push(@cpu_cnt_day_graph_args, "GPRINT:$items[0]:MIN:\"%6.2lf\"");
      push(@cpu_cnt_day_graph_args, "GPRINT:$items[0]:AVERAGE:\"%6.2lf\"");
      push(@cpu_cnt_day_graph_args, "--upper-limit=$cpu_upper_limit");
        
      push(@cpu_cnt_week_graph_args, "DEF:$items[0]=${top_dir}data/$group_items[0]_cpu_cur.rrd:$items[0]:AVERAGE");
      push(@cpu_cnt_week_graph_args, "AREA:$items[0]$colors[$cnt]:$items[0]");
      push(@cpu_cnt_week_graph_args, "LINE3:$cpu_max#FF0000:\"CPU High\"");
      push(@cpu_cnt_week_graph_args, "LINE3:$cpu_min#0000FF:\"CPU Low\"");      
      push(@cpu_cnt_week_graph_args, "COMMENT:\"  \\n\"");    
      push(@cpu_cnt_week_graph_args, "COMMENT:\"---------------------------\\n\"");
      push(@cpu_cnt_week_graph_args, "COMMENT:\"Maximum  Minimum  Average\\n\"");
      push(@cpu_cnt_week_graph_args, "GPRINT:$items[0]:MAX:\"%7.2lf\"");
      push(@cpu_cnt_week_graph_args, "GPRINT:$items[0]:MIN:\"%6.2lf\"");
      push(@cpu_cnt_week_graph_args, "GPRINT:$items[0]:AVERAGE:\"%6.2lf\"");  
      push(@cpu_cnt_week_graph_args, "--upper-limit=$cpu_upper_limit");
          
      push(@cpu_cnt_month_graph_args, "DEF:$items[0]=${top_dir}data/$group_items[0]_cpu_cur.rrd:$items[0]:AVERAGE");
      push(@cpu_cnt_month_graph_args, "AREA:$items[0]$colors[$cnt]:$items[0]");
      push(@cpu_cnt_month_graph_args, "LINE3:$cpu_max#FF0000:\"CPU High\"");
      push(@cpu_cnt_month_graph_args, "LINE3:$cpu_min#0000FF:\"CPU Low\"");      
      push(@cpu_cnt_month_graph_args, "COMMENT:\"  \\n\"");    
      push(@cpu_cnt_month_graph_args, "COMMENT:\"---------------------------\\n\"");
      push(@cpu_cnt_month_graph_args, "COMMENT:\"Maximum  Minimum  Average\\n\"");
      push(@cpu_cnt_month_graph_args, "GPRINT:$items[0]:MAX:\"%7.2lf\"");
      push(@cpu_cnt_month_graph_args, "GPRINT:$items[0]:MIN:\"%6.2lf\"");
      push(@cpu_cnt_month_graph_args, "GPRINT:$items[0]:AVERAGE:\"%6.2lf\""); 
      push(@cpu_cnt_month_graph_args, "--upper-limit=$cpu_upper_limit");
              
      push(@cpu_cnt_quarter_graph_args, "DEF:$items[0]=${top_dir}data/$group_items[0]_cpu_cur.rrd:$items[0]:AVERAGE");
      push(@cpu_cnt_quarter_graph_args, "AREA:$items[0]$colors[$cnt]:$items[0]");
      push(@cpu_cnt_quarter_graph_args, "LINE3:$cpu_max#FF0000:\"CPU High\"");
      push(@cpu_cnt_quarter_graph_args, "LINE3:$cpu_min#0000FF:\"CPU Low\"");
      push(@cpu_cnt_quarter_graph_args, "COMMENT:\"  \\n\"");    
      push(@cpu_cnt_quarter_graph_args, "COMMENT:\"---------------------------\\n\"");
      push(@cpu_cnt_quarter_graph_args, "COMMENT:\"Maximum  Minimum  Average\\n\"");
      push(@cpu_cnt_quarter_graph_args, "GPRINT:$items[0]:MAX:\"%7.2lf\"");
      push(@cpu_cnt_quarter_graph_args, "GPRINT:$items[0]:MIN:\"%6.2lf\"");
      push(@cpu_cnt_quarter_graph_args, "GPRINT:$items[0]:AVERAGE:\"%6.2lf\"");
      push(@cpu_cnt_quarter_graph_args, "--upper-limit=$cpu_upper_limit");
              
      push(@cpu_cnt_year_graph_args, "DEF:$items[0]=${top_dir}data/$group_items[0]_cpu_cur.rrd:$items[0]:AVERAGE");
      push(@cpu_cnt_year_graph_args, "AREA:$items[0]$colors[$cnt]:$items[0]");  
      push(@cpu_cnt_year_graph_args, "LINE3:$cpu_max#FF0000:\"CPU High\"");
      push(@cpu_cnt_year_graph_args, "LINE3:$cpu_min#0000FF:\"CPU Low\"");        
      push(@cpu_cnt_year_graph_args, "COMMENT:\"  \\n\"");    
      push(@cpu_cnt_year_graph_args, "COMMENT:\"---------------------------\\n\"");
      push(@cpu_cnt_year_graph_args, "COMMENT:\"Maximum  Minimum  Average\\n\"");
      push(@cpu_cnt_year_graph_args, "GPRINT:$items[0]:MAX:\"%7.2lf\"");
      push(@cpu_cnt_year_graph_args, "GPRINT:$items[0]:MIN:\"%6.2lf\"");
      push(@cpu_cnt_year_graph_args, "GPRINT:$items[0]:AVERAGE:\"%6.2lf\"");  
      push(@cpu_cnt_year_graph_args, "--upper-limit=$cpu_upper_limit");
    } else {
      $is_cnt_checked="";
      $is_load_checked="checked";    
      $cpu_title="CPU Load Statistics"; 
      get_cpu_load_high_low($group_items[1], $items[0]);    
      #
      # Number of CPU load argument generation
      #
      push(@cpu_load_day_graph_args, "DEF:$items[0]=${top_dir}data/$group_items[0]_cpu_load.rrd:$items[0]:AVERAGE");
      push(@cpu_load_day_graph_args, "AREA:$items[0]$colors[$cnt]:$items[0]");
      push(@cpu_load_day_graph_args, "LINE3:$cpu_load_high#FF0000:\"Load High\"");
      push(@cpu_load_day_graph_args, "LINE3:$cpu_load_low#0000FF:\"Load Low\"");
      push(@cpu_load_day_graph_args, "COMMENT:\"  \\n\"");    
      push(@cpu_load_day_graph_args, "COMMENT:\"---------------------------\\n\"");
      push(@cpu_load_day_graph_args, "COMMENT:\"Maximum  Minimum  Average\\n\"");
      push(@cpu_load_day_graph_args, "GPRINT:$items[0]:MAX:\"%7.2lf\"");
      push(@cpu_load_day_graph_args, "GPRINT:$items[0]:MIN:\"%6.2lf\"");
      push(@cpu_load_day_graph_args, "GPRINT:$items[0]:AVERAGE:\"%6.2lf\"");

        
      push(@cpu_load_week_graph_args, "DEF:$items[0]=${top_dir}data/$group_items[0]_cpu_load.rrd:$items[0]:AVERAGE");
      push(@cpu_load_week_graph_args, "AREA:$items[0]$colors[$cnt]:$items[0]");
      push(@cpu_load_week_graph_args, "LINE3:$cpu_load_high#FF0000:\"Load High\"");
      push(@cpu_load_week_graph_args, "LINE3:$cpu_load_low#0000FF:\"Load Low\"");      
      push(@cpu_load_week_graph_args, "COMMENT:\"  \\n\"");    
      push(@cpu_load_week_graph_args, "COMMENT:\"---------------------------\\n\"");
      push(@cpu_load_week_graph_args, "COMMENT:\"Maximum  Minimum  Average\\n\"");
      push(@cpu_load_week_graph_args, "GPRINT:$items[0]:MAX:\"%7.2lf\"");
      push(@cpu_load_week_graph_args, "GPRINT:$items[0]:MIN:\"%6.2lf\"");
      push(@cpu_load_week_graph_args, "GPRINT:$items[0]:AVERAGE:\"%6.2lf\"");  
    
      push(@cpu_load_month_graph_args, "DEF:$items[0]=${top_dir}data/$group_items[0]_cpu_load.rrd:$items[0]:AVERAGE");
      push(@cpu_load_month_graph_args, "AREA:$items[0]$colors[$cnt]:$items[0]");
      push(@cpu_load_month_graph_args, "LINE3:$cpu_load_high#FF0000:\"Load High\"");
      push(@cpu_load_month_graph_args, "LINE3:$cpu_load_low#0000FF:\"Load Low\"");      
      push(@cpu_load_month_graph_args, "COMMENT:\"  \\n\"");    
      push(@cpu_load_month_graph_args, "COMMENT:\"---------------------------\\n\"");
      push(@cpu_load_month_graph_args, "COMMENT:\"Maximum  Minimum  Average\\n\"");
      push(@cpu_load_month_graph_args, "GPRINT:$items[0]:MAX:\"%7.2lf\"");
      push(@cpu_load_month_graph_args, "GPRINT:$items[0]:MIN:\"%6.2lf\"");
      push(@cpu_load_month_graph_args, "GPRINT:$items[0]:AVERAGE:\"%6.2lf\""); 
        
      push(@cpu_load_quarter_graph_args, "DEF:$items[0]=${top_dir}data/$group_items[0]_cpu_load.rrd:$items[0]:AVERAGE");
      push(@cpu_load_quarter_graph_args, "AREA:$items[0]$colors[$cnt]:$items[0]");
      push(@cpu_load_quarter_graph_args, "LINE3:$cpu_load_high#FF0000:\"Load High\"");
      push(@cpu_load_quarter_graph_args, "LINE3:$cpu_load_low#0000FF:\"Load Low\"");      
      push(@cpu_load_quarter_graph_args, "COMMENT:\"  \\n\"");    
      push(@cpu_load_quarter_graph_args, "COMMENT:\"---------------------------\\n\"");
      push(@cpu_load_quarter_graph_args, "COMMENT:\"Maximum  Minimum  Average\\n\"");
      push(@cpu_load_quarter_graph_args, "GPRINT:$items[0]:MAX:\"%7.2lf\"");
      push(@cpu_load_quarter_graph_args, "GPRINT:$items[0]:MIN:\"%6.2lf\"");
      push(@cpu_load_quarter_graph_args, "GPRINT:$items[0]:AVERAGE:\"%6.2lf\"");
        
      push(@cpu_load_year_graph_args, "DEF:$items[0]=${top_dir}data/$group_items[0]_cpu_load.rrd:$items[0]:AVERAGE");
      push(@cpu_load_year_graph_args, "AREA:$items[0]$colors[$cnt]:$items[0]");  
      push(@cpu_load_year_graph_args, "LINE3:$cpu_load_high#FF0000:\"Load High\"");
      push(@cpu_load_year_graph_args, "LINE3:$cpu_load_low#0000FF:\"Load Low\"");          
      push(@cpu_load_year_graph_args, "COMMENT:\"  \\n\"");    
      push(@cpu_load_year_graph_args, "COMMENT:\"---------------------------\\n\"");
      push(@cpu_load_year_graph_args, "COMMENT:\"Maximum  Minimum  Average\\n\"");
      push(@cpu_load_year_graph_args, "GPRINT:$items[0]:MAX:\"%7.2lf\"");
      push(@cpu_load_year_graph_args, "GPRINT:$items[0]:MIN:\"%6.2lf\"");
      push(@cpu_load_year_graph_args, "GPRINT:$items[0]:AVERAGE:\"%6.2lf\"");      
    }
  } else {
    $partition_select_html = $partition_select_html . "<option value='$items[0]'>$items[0]</option>";
  }
  $cnt=$cnt+1;
}

#
# Generating CPU utilization graph for each PLM group
#
system "rrdtool graph @cpu_pct_day_graph_args 1>/dev/null";
system "rrdtool graph @cpu_pct_week_graph_args 1>/dev/null";
system "rrdtool graph @cpu_pct_month_graph_args 1>/dev/null";
system "rrdtool graph @cpu_pct_quarter_graph_args 1>/dev/null";
system "rrdtool graph @cpu_pct_year_graph_args 1>/dev/null";
if ($req_cpu_choice eq "cnt") {
  system "rrdtool graph @cpu_cnt_day_graph_args 1>/dev/null";
  system "rrdtool graph @cpu_cnt_week_graph_args 1>/dev/null";
  system "rrdtool graph @cpu_cnt_month_graph_args 1>/dev/null";
  system "rrdtool graph @cpu_cnt_quarter_graph_args 1>/dev/null";
  system "rrdtool graph @cpu_cnt_year_graph_args 1>/dev/null";
} else {
  system "rrdtool graph @cpu_load_day_graph_args 1>/dev/null";
  system "rrdtool graph @cpu_load_week_graph_args 1>/dev/null";
  system "rrdtool graph @cpu_load_month_graph_args 1>/dev/null";
  system "rrdtool graph @cpu_load_quarter_graph_args 1>/dev/null";
  system "rrdtool graph @cpu_load_year_graph_args 1>/dev/null";
}

print <<HTMLEND;
<form method="get" action="./oms-cpu-partition-query.html">
      <table width="950" cellpadding="1" cellspacing="1">
        <tr>
          <td colspan="2" align="left">
          	<table width="500" cellpadding="1" cellspacing="1">
          		<tr>
          			<td width="150"><b>Server Group Name</b></td>
          			<td>$req_group</td>
          		</tr>
          		<tr>
          			<td width="150"><b>Partition</b></td>
          			<td>         		
		              <select name="partition">
		                $partition_select_html
		              </select>          		
		             </td>
		          </tr>
          		<tr>
          			<td width="150"><b>Report Type</b></td>
          			<td>             			
          				<input type="radio" name="cpu_choice" value="cnt" $is_cnt_checked>CPU Allocation
            			<input type="radio" name="cpu_choice" value="load" $is_load_checked>CPU Load
            		</td>
          		</tr>
          		<tr>
          			<td width="150"><b>End Date</b></td>
          			<td>
	                <input type="text" name="year" size="4" maxlength="4" value="$end_year">
	                Year 
	                <input type="text" name="month" size="2" maxlength="2" value="$end_month">
	                Month
	                <input type="text" name="day" size="2" maxlength="2" value="$end_day">
	                Day
	                <input type="hidden" name="group" value="$req_group">
	                <input type="submit" value="Query">          			
          			</td>
          		</tr> 
          	</table>         		
          </td>
        </tr>
        <tr> 
          <td>
    			  <table width="100%" cellpadding="4" cellspacing="4">
    				  <tr>
    								<td bgcolor="#000000"><font color="#FFFFFF">CPU Utilization Statistics</font> </td>
    				  </tr>
    				  <tr>
    				    <td align=center>
    				      <br>
    				      <img src="${htdocs_dir}oms/images/oms-cpu-partition-day-$group_items[0]-$req_partition.gif"><br><br>
     				      <img src="${htdocs_dir}oms/images/oms-cpu-partition-week-$group_items[0]-$req_partition.gif"><br><br>
     				      <img src="${htdocs_dir}oms/images/oms-cpu-partition-month-$group_items[0]-$req_partition.gif"><br><br>
     				      <img src="${htdocs_dir}oms/images/oms-cpu-partition-quarter-$group_items[0]-$req_partition.gif"><br><br>
     				      <img src="${htdocs_dir}oms/images/oms-cpu-partition-year-$group_items[0]-$req_partition.gif">    				           				           				      
     				    </td>
    				  </tr>
    			  </table>
    		  </td>
          <td>
    			  <table width="100%" cellpadding="4" cellspacing="4">
    				  <tr>
    								<td bgcolor="#000000"><font color="#FFFFFF">$cpu_title</font> </td>
    				  </tr>
    				  <tr>
    				    <td align=center>
    				      <br>
    				      <img src="${htdocs_dir}oms/images/oms-cpu-$req_cpu_choice-partition-day-$group_items[0]-$req_partition.gif"><br><br>
     				      <img src="${htdocs_dir}oms/images/oms-cpu-$req_cpu_choice-partition-week-$group_items[0]-$req_partition.gif"><br><br>
     				      <img src="${htdocs_dir}oms/images/oms-cpu-$req_cpu_choice-partition-month-$group_items[0]-$req_partition.gif"><br><br>
     				      <img src="${htdocs_dir}oms/images/oms-cpu-$req_cpu_choice-partition-quarter-$group_items[0]-$req_partition.gif"><br><br>
     				      <img src="${htdocs_dir}oms/images/oms-cpu-$req_cpu_choice-partition-year-$group_items[0]-$req_partition.gif">    				           				           				      
     				    </td>
    				  </tr>    				  
    			  </table>		  
    		  </td>
        </tr>
      </table>
</form>      
HTMLEND
  }
}
